class Enum:
    def __init__(self):
        pass


class MessageType:
    APIMessage = 0
    Control = 1
    Data = 2
    Preference = 3
    Program = 4
    DongleCommand = 5
    DongleEvent = 6
    USBCommand = 7
    USBEvent = 8
    PreferenceRequest = 9
    State = 10
    StateRequest = 11

    A_P_I_MESSAGE = 0
    CONTROL = 1
    DATA = 2
    PREFERENCE = 3
    PROGRAM = 4
    DONGLE_COMMAND = 5
    DONGLE_EVENT = 6
    U_S_B_COMMAND = 7
    U_S_B_EVENT = 8
    PREFERENCE_REQUEST = 9
    STATE = 10
    STATE_REQUEST = 11


class APIMessage:
    NotSupported = 0

    NOT_SUPPORTED = 0


class Control:
    ActivateMotors = 0
    DeactivateMotors = 1
    Motors = 2
    LightsRGB = 3
    SyncLightsRGB = 4
    PowerOff = 5
    Disconnect = 7
    SetupWait = 12
    MotorsWithWait = 13
    PlayNote = 16
    PlaySong = 17
    Lights = 18

    ACTIVATE_MOTORS = 0
    DEACTIVATE_MOTORS = 1
    MOTORS = 2
    LIGHTS_R_G_B = 3
    SYNC_LIGHTS_R_G_B = 4
    POWER_OFF = 5
    DISCONNECT = 7
    SETUP_WAIT = 12
    MOTORS_WITH_WAIT = 13
    PLAY_NOTE = 16
    PLAY_SONG = 17
    LIGHTS = 18


class Data:
    Ultrasonic = 0
    Accelerometer = 1
    Gyroscope = 2
    Temperature = 3
    Battery = 4

    ULTRASONIC = 0
    ACCELEROMETER = 1
    GYROSCOPE = 2
    TEMPERATURE = 3
    BATTERY = 4


class Preference:
    MotorLeftFlip = 0
    MotorRightFlip = 1
    Name = 2
    UltrasonicFiltering = 3
    Reset = 4

    MOTOR_LEFT_FLIP = 0
    MOTOR_RIGHT_FLIP = 1
    NAME = 2
    ULTRASONIC_FILTERING = 3
    RESET = 4


class Program:
    Started = 0
    Ended = 1
    DoneWaiting = 2

    STARTED = 0
    ENDED = 1
    DONE_WAITING = 2


class USBCommand:
    Unsupported = 255
    GetFirmwareVersion = 0
    GetHardwareVersion = 1

    UNSUPPORTED = 255
    GET_FIRMWARE_VERSION = 0
    GET_HARDWARE_VERSION = 1


class USBEvent:
    Unsupported = 255
    FirmwareVersion = 0
    HardwareVersion = 1

    UNSUPPORTED = 255
    FIRMWARE_VERSION = 0
    HARDWARE_VERSION = 1


class State:
    Undefined = 255
    Remote = 0
    Dance = 1
    Piano = 2
    Avoid = 3

    UNDEFINED = 255
    REMOTE = 0
    DANCE = 1
    PIANO = 2
    AVOID = 3


class OutgoingUSBMessageType:
    Echo = 0
    BeginScanning = 1
    EndScanning = 2
    Connect = 3
    PassThrough = 4
    ResetBLE = 5
    RequestHardwareVersion = 6
    RequestFirmwareVersion = 7
    EchoASCII = 48

    ECHO = 0
    BEGIN_SCANNING = 1
    END_SCANNING = 2
    CONNECT = 3
    PASS_THROUGH = 4
    RESET_B_L_E = 5
    REQUEST_HARDWARE_VERSION = 6
    REQUEST_FIRMWARE_VERSION = 7
    ECHO_A_S_C_I_I = 48


class IncomingUSBMessageType:
    NewRobot = 0
    RobotConnected = 1
    RobotDisconnected = 2
    Debug = 3
    HardwareVersion = 4
    FirmwareVersion = 5
    RobotPacket = 160

    NEW_ROBOT = 0
    ROBOT_CONNECTED = 1
    ROBOT_DISCONNECTED = 2
    DEBUG = 3
    HARDWARE_VERSION = 4
    FIRMWARE_VERSION = 5
    ROBOT_PACKET = 160


class Color:
    Turquoise = (26, 188, 156,)
    GreenSea = (22, 160, 133,)
    Emerald = (46, 204, 113,)
    Nephritis = (39, 174, 96,)
    PeterRiver = (52, 152, 219,)
    BelizeHole = (41, 128, 185,)
    Amethyst = (155, 89, 182,)
    Wisteria = (142, 68, 173,)
    WetAsphalt = (52, 73, 94,)
    MidnightBlue = (44, 62, 80,)
    Sunflower = (241, 196, 15,)
    Orange = (243, 156, 18,)
    Carrot = (230, 126, 34,)
    Pumpkin = (211, 84, 0,)
    Alizarin = (231, 76, 60,)
    Pomegranate = (192, 57, 43,)
    Clouds = (236, 240, 241,)
    Silver = (189, 195, 199,)
    Concrete = (149, 165, 166,)
    Asbestos = (127, 140, 141,)

    TURQUOISE = (26, 188, 156,)
    GREEN_SEA = (22, 160, 133,)
    EMERALD = (46, 204, 113,)
    NEPHRITIS = (39, 174, 96,)
    PETER_RIVER = (52, 152, 219,)
    BELIZE_HOLE = (41, 128, 185,)
    AMETHYST = (155, 89, 182,)
    WISTERIA = (142, 68, 173,)
    WET_ASPHALT = (52, 73, 94,)
    MIDNIGHT_BLUE = (44, 62, 80,)
    SUNFLOWER = (241, 196, 15,)
    ORANGE = (243, 156, 18,)
    CARROT = (230, 126, 34,)
    PUMPKIN = (211, 84, 0,)
    ALIZARIN = (231, 76, 60,)
    POMEGRANATE = (192, 57, 43,)
    CLOUDS = (236, 240, 241,)
    SILVER = (189, 195, 199,)
    CONCRETE = (149, 165, 166,)
    ASBESTOS = (127, 140, 141,)


class Motor:
    Left = 0
    Right = 1

    LEFT = 0
    RIGHT = 1


class MotorDirection:
    Forward = 0
    Backward = 1

    FORWARD = 0
    BACKWARD = 1


class WaitType:
    Time = 0
    UltrasonicGreaterThan = 1
    UltrasonicLessThan = 2
    Song = 3
    Distance = 4
    Rotation = 5

    TIME = 0
    ULTRASONIC_GREATER_THAN = 1
    ULTRASONIC_LESS_THAN = 2
    SONG = 3
    DISTANCE = 4
    ROTATION = 5


class Light:
    Red = 0
    Green = 1
    Yellow = 2

    RED = 0
    GREEN = 1
    YELLOW = 2


class Note:
    C = 0
    CSharp = 1
    D = 2
    EFlat = 3
    E = 4
    F = 5
    FSharp = 6
    G = 7
    GSharp = 8
    A = 9
    BFlat = 10
    B = 11

    C = 0
    C_SHARP = 1
    D = 2
    E_FLAT = 3
    E = 4
    F = 5
    F_SHARP = 6
    G = 7
    G_SHARP = 8
    A = 9
    B_FLAT = 10
    B = 11


class Song:
    StarWars = 0
    Rocky = 1
    EyeOfTheTiger = 2
    Mario = 3
    Pokemon = 4

    STAR_WARS = 0
    ROCKY = 1
    EYE_OF_THE_TIGER = 2
    MARIO = 3
    POKEMON = 4


class MessageLengthIndexes:
    indexes = {
        0: 1,
        1: 1,
        2: 1,
        3: 1,
        4: 2,
        5: 2,
        160: 2,
    }

    @classmethod
    def get(cls, code):
        return cls.indexes[code]



